#!/usr/bin/env python
# -*- coding: utf-8 -*-

'''
Utilitaires pour le TP WSD
'''

# list of English stop words
STOP_WORDS= set( ['a','able','about','across','after','all','almost','also','am','among','an','and','any','are','as','at','be','because','been','but','by','can','cannot','could','dear','did','do','does','either','else','ever','every','for','from','get','got','had','has','have','he','her','hers','him','his','how','however','i','if','in','into','is','it','its','just','least','let','like','likely','may','me','might','most','must','my','neither','no','nor','not','of','off','often','on','one','only','or','other','our','own','rather','said','say','says','she','should','since','so','some','than','that','the','their','them','then','there','these','they','this','tis','to','too','twas','two','us','wants','was','we','were','what','when','where','which','while','who','whom','why','will','with','would','yet','you','your'] )


def normalize_and_split(sentence):
    return [ x.strip().strip('.').strip(',') for x in sentence.lower().split() ]


# division des donnees en 2 ens
# big contiendra 100*(n-1)/n % des données,
# small contiendra 100/n % des données
def data_split( examples, n=5 ):
    big = []; small =  []
    for i,ex in enumerate(examples):
        if i % n == 0:
            small.append( ex )
        else:
            big.append( ex )
    return big, small


# calcul de la distribution des sens dans la liste d'exemples
def sense_distribution( examples ):
    sense_distrib = {}
    for ex in examples:
        s = ex.sense()
        sense_distrib[s] = sense_distrib.get(s,0) + 1
    return sense_distrib


# correspondances entre synset de WordNet et sensid de TWA
WN_CORRESPONDANCES = {
    'bass' : {
        'bass%music' : ['bass.n.01','bass.n.02','bass.n.03','bass.n.06','bass.n.07'],
        'bass%fish' : ['sea_bass.n.01','freshwater_bass.n.01','bass.n.08']
        },
    'crane' : {
        'crane%machine' : ['crane.n.04'],
        'crane%bird' : ['crane.n.05']
        },
    'motion' : {
        'motion%physical' : ['gesture.n.02','movement.n.03','motion.n.03','motion.n.04','motion.n.06'],
        'motion%legal' : ['motion.n.05']
        },
    'palm' : {
        'palm%hand' : ['palm.n.01'], # 'palm.n.02' ?
        'palm%tree' : ['palm.n.03']
        },
    'plant' : {
        'plant%factory' : ['plant.n.01'],
        'plant%living' : ['plant.n.02']
        },
    'tank' : {
        'tank%vehicle' : ['tank.n.01'], # 'tank_car.n.01'?
        'tank%container' : ['tank.n.02']
        }
    }

# Premier sens WN pour chaque lemme désambiguisés de TWA
# (= most freq sense in SemCor)
WN_FIRST_SENSE={
    'bass' : 'bass%music',
    'crane' : 'crane%machine',
    'motion' : 'motion%physical',
    'palm' : 'palm%hand',
    'plant' : 'plant%factory',
    'tank' : 'tank%vehicle'
    }

